package m.b.core;

import java.util.*;
import m.util.*;

public class Config {
  public static final double version=1.04;
  public static double speed=1.11;
  public static final int squareSize=30;
  public static final int hSquareSize=squareSize/2;
  public static double cameraSpeed=0.044;
  public static final double activationDistance=3;
  public static double bulletGrowth=0.030;
  public static final String logfile="C:/tomcat/webapps/ROOT/log/battery.log";
  public static final boolean debugMode=false;

  /*numbers of image map*/
  public static List<Integer> levels=getLevels();

  public static List<Integer> getLevels() {
    Integer[] lvls={1, 2, 5, 4};
    return Arrays.asList(lvls);
  }

  public static final String getLevelsString() {
    return Str77.toString(levels);
  }

  public static class Decor {
    /*
     * Instead of carpet
     */
    public static boolean bck0=false;
    public static boolean grass=true;
  }

  public class Server {
    public static final String site="btrgame.com";
    public static final int port=6564;
  }

  public class Replay {
    public static final boolean active=false;
    public static final int conId=100041993;
    public static final int port=6555;
    public static final double fpsLogPeriod=10000;
  }

  public static class Intervals {
    public static double nextLevelDelay=2500;
    public static double afterShotTime=290;
  }

  public static class Monsters {
    public static final int maxCollisionCount=30;
    public static double defaultA=0.015;
    public static double afterDmgTime=250;

    public static class FirstAid {
      public static final double bigRotRadius=12;
      public static final double smallRotRadius=4;
      public static double bigRotSpeed=U77.dpi*Time77.step/3000;
      public static double smallRotSpeed=U77.dpi*Time77.step/349;
      public static final double effect=25;
    }

    public static class Player {
      /*
       * Pixels in millisecond
       */
      public static double maxSpeed=0.13;
      public static double maxStrafeSpeed=0.065;
      public static double minSpeed=0.039;
      public static final double life=100;
      public static double afterDmgTime=600;
    }

    public static class EnPlane {
      public static double speed=0.09;
      public static double shiftSpeed=0.06;
      public static double turnSpeed=0.01;
      public static double life=60;
    }

    public static class Heli {
      public static double maxSpeed=0.083;
      public static final double life=40;
      public static double bladesK=0.02;
    }

    public static class Tank {
      public static double turnDistance=1400;
      public static double speed=0.018;
      public static double shotInterval=700;
      public static final double life=60;
      public static double stayPeriod=500;
      public static double bulletSpeed=0.15;
      public static double wishForPlayer=0.65;
    }

    public static class Bullet {
      public static double speed=0.388;
      public static final double startShift=3;
    }
  }

  public class Damages {
    public static final double bullet=20;
    public static final double square=10;
    public static final double monster=30;
  }
}
