/* refactoring0 */
package m.b.core;

import java.util.*;
import m.b.*;
import m.util.*;

public class ConfigLoader {
  Battery btr;
  public ConfigLoader(Battery battery) {
    btr=battery;
    initConfig();
    logConfig();
  }

  private final void initConfig() {
    if (!Config.Replay.active) {
      try {
        btr.name=getParam("name");
      } catch(Exception e) {
      }
    }
    try {
      setLevels(getParam("levels"));
    } catch (Exception e) {
      P.p("probably error getting levels parameter");
      Config.levels=Config.getLevels();
    }
    Config.speed=getDouble("speed", Config.speed);
    double speed=Config.speed;
    Config.Monsters.Player.maxSpeed =
        getDouble("maxSpeed", Config.Monsters.Player.maxSpeed)*speed;
    Config.Monsters.Player.maxStrafeSpeed =
        getDouble("maxStrafeSpeed", Config.Monsters.Player.maxStrafeSpeed)*
        speed;
    Config.Monsters.Player.minSpeed =
        getDouble("minSpeed", Config.Monsters.Player.minSpeed)*speed;
    Config.Monsters.Heli.maxSpeed=
        getDouble("heliMaxSpeed", Config.Monsters.Heli.maxSpeed)*speed;
    Config.cameraSpeed=
        getDouble("cameraSpeed", Config.cameraSpeed)*speed;
    Config.Monsters.Tank.speed=
        getDouble("tankSpeed", Config.Monsters.Tank.speed)*speed;
    Config.Monsters.Tank.wishForPlayer=
        getDouble("tankForPlayer", Config.Monsters.Tank.wishForPlayer);
    Config.bulletGrowth=
        getDouble("bulletGrowth", Config.bulletGrowth)*speed;
    Config.Monsters.defaultA=
        getDouble("defaultA", Config.Monsters.defaultA);
    Config.Monsters.Tank.turnDistance=
        getDouble("tankTurn", Config.Monsters.Tank.turnDistance)/speed;
    Config.Monsters.Tank.stayPeriod=
        getDouble("tankStays", Config.Monsters.Tank.stayPeriod)/speed;
    Config.Monsters.Bullet.speed=
        getDouble("bulletSpeed", Config.Monsters.Bullet.speed)*speed;
    Config.Intervals.afterShotTime=
        getDouble("shotInterval", Config.Intervals.afterShotTime)/speed;
    Config.Intervals.nextLevelDelay=
        getDouble("nextLvlDelay", Config.Intervals.nextLevelDelay);
    Config.Decor.bck0=getBool("bck0", Config.Decor.bck0);
    Config.Decor.grass=getBool("grass", Config.Decor.grass);
    Config.Monsters.Player.afterDmgTime=
        getDouble("afterDmg", Config.Monsters.Player.afterDmgTime)/speed;
    Config.Monsters.afterDmgTime=
        getDouble("monAfterDmg", Config.Monsters.afterDmgTime)/speed;
    Config.Monsters.FirstAid.bigRotSpeed *= speed;
    Config.Monsters.FirstAid.smallRotSpeed *= speed;
    Config.Monsters.Tank.shotInterval /= speed;
    Config.Monsters.Heli.bladesK *= speed;
  }

  private final void logConfig() {
    Logger logger=btr.logger;
    logger.log("start clienttime:"+System.currentTimeMillis());
    logger.log("version "+Config.version);
    double speed=Config.speed;
    logger.log("speed "+speed);
    logger.log("maxSpeed "+Config.Monsters.Player.maxSpeed/speed);
    logger.log("maxStrafeSpeed "+
        Config.Monsters.Player.maxStrafeSpeed/speed);
    logger.log("minSpeed "+Config.Monsters.Player.minSpeed/speed);
    logger.log("heliMaxSpeed "+Config.Monsters.Heli.maxSpeed/speed);
    logger.log("levels "+Config.getLevelsString());
    logger.log("cameraSpeed "+Config.cameraSpeed/speed);
    logger.log("tankSpeed "+Config.Monsters.Tank.speed/speed);
    logger.log("tankForPlayer "+Config.Monsters.Tank.wishForPlayer);
    logger.log("bulletGrowth "+Config.bulletGrowth/speed);
    logger.log("defaultA "+Config.Monsters.defaultA);
    logger.log("tankTurn "+Config.Monsters.Tank.turnDistance*speed);
    logger.log("tankStays "+Config.Monsters.Tank.stayPeriod*speed);
    logger.log("bulletSpeed "+Config.Monsters.Bullet.speed/speed);
    logger.log("shotInterval "+Config.Intervals.afterShotTime*speed);
    logger.log("nextLvlDelay "+Config.Intervals.nextLevelDelay);
    logger.log("bck0 "+Config.Decor.bck0);
    logger.log("grass "+Config.Decor.grass);
    logger.log("name "+btr.name);
  }

  public static final void setLevels(String s) {
    Integer[] lvls={new Integer(""+s.charAt(0)), new Integer(""+s.charAt(2)),
        new Integer(""+s.charAt(4)), new Integer(""+s.charAt(6)),
        new Integer(""+s.charAt(8))};
    Config.levels=Arrays.asList(lvls);
  }

  private final double getDouble(String paramName, double defaultValue) {
    try {
      return Double.parseDouble(getParam(paramName));
    } catch(Exception e) {
      P.p("error getting "+paramName+" parameter");
      return defaultValue;
    }
  }

  private final boolean getBool(String paramName, boolean defaultValue) {
    try {
      return getParam(paramName).equals("true");
    } catch(Exception e) {
      P.p("error getting "+paramName+" parameter");
      return defaultValue;
    }
  }

  /**
   * @return null on error
   */
  private final String getParam(String name) {
    if (Config.Replay.active) {
      return btr.kbd.replayClient.getParam(name);
    } else {
      String res=btr.getParameter(name);
      if (res==null || res.equals("")) {
        throw new RuntimeException("error getting "+name+" parameter");
      }
      return res;
    }
  }
}
