package m.b.core;

import java.net.*;
import java.io.*;
import java.util.*;
import m.util.*;

public class LoggerConnection implements Runnable {
  private ServerLogger serverLogger;
  private BufferedReader in;
  private int id;
  private String ip;

  private static int maxId=new Random(System.currentTimeMillis()).nextInt();

  public LoggerConnection(ServerLogger serverLogger, Socket sock) {
    try {
      this.serverLogger=serverLogger;
      sock.setSoTimeout(30000);
      maxId++;
      id=maxId;
      in=new BufferedReader(new InputStreamReader(sock.getInputStream()));
      ip=sock.getInetAddress().getHostAddress();
      serverLogger.incConCount(ip);
      serverLogger.log("\n"+id+" addr:"+ip+" time:"+System.currentTimeMillis()+
          " "+Date77.time(System.currentTimeMillis()));
      new Thread(this).start();
    } catch(Exception e) {
      e.printStackTrace();
      serverLogger.log(U77.toString(e));
    }
  }

  public void run() {
    while (true) {
      try {
        String s=in.readLine();
        if (s != null) {
          serverLogger.log("" + id + " " + s);
        } else {
          serverLogger.decConCount(ip);
          return;
        }
      } catch(Exception e) {
        if ((!e.toString().startsWith("java.net.SocketException")) &&
            (!(e instanceof SocketTimeoutException))) {
          e.printStackTrace();
          serverLogger.log(U77.toString(e));
        } else {
          serverLogger.decConCount(ip);
          return;
        }
      }
    }
  }
}
