package m.b.core;

import java.io.*;
import java.net.*;
import java.util.*;
import m.b.*;
import m.util.*;

public class ReplayClient {
  private PrintWriter out;
  private BufferedReader in;
  private List<String> toLog;
  private Battery bat;
  private Time77 time;

  public ReplayClient(Battery bat) {
    try {
      this.bat=bat;
      toLog=new ArrayList();
      Socket s=new Socket(Config.Server.site, Config.Replay.port);
      out=new PrintWriter(s.getOutputStream(), true);
      in=new BufferedReader(new InputStreamReader(s.getInputStream()));
      time=bat.time;
    } catch(Exception e) {
      e.printStackTrace();
      bat.exception(e);
    }
  }

  public final void stop() {
    try {
      in.close();
      out.close();
    } catch (Exception ignored) {}
  }

  public int getEventCount() {
    out.println("" + time.time);
    return new Integer(read()).intValue();
  }

  public String getParam(String paramName) {
    out.println(paramName+"?");
    return read();
  }

  public String getKey() {
    return read();
  }

  public boolean pressed() {
    return read().equals("true");
  }

  private String read() {
    try {
      return in.readLine();
    } catch(Exception e) {
      bat.exception(e);
      return "";
    }
  }
}
