package m.b.core;

import java.net.*;
import java.io.*;
import m.util.*;

public class ReplayServer implements Runnable {
  private long id;
  private String logFile;

  public static void main(String[] args) {
    try {
      String in="C:/tomcat/webapps/ROOT/log/battery.log";
      long id=Config.Replay.conId;
      if (args.length>1) {
        in=args[0];
        id=new Long(args[1]).longValue();
      } else {
        P.p("Call with 2 parameters:");
        P.p("  The first - path to log file");
        P.p("    Default path:"+in);
        P.p("  Second - replay id");
        P.p("    Default value (Config.ReplayMode.conId):"+id+"\n");
      }
      new Thread(new ReplayServer(in, id)).start();
    } catch(Exception e) {
      e.printStackTrace();
    }
  }

  private ReplayServer(String logFile, long id) {
    this.logFile=logFile;
    this.id=id;
    P.p("ReplayServer started at "+Date77.datetime()+
          " and listens "+Config.Replay.port+" port...");
    P.p("log file:"+logFile);
    P.p("replay:"+id);
  }

  public void run() {
    try {
      ServerSocket acceptSocket=new ServerSocket(Config.Replay.port);
      while (true) {
        new ReplayConnection(acceptSocket.accept(),id,new FileReader77(logFile));
      }
    } catch(Exception ignored) {}
  }
}
