/* refactoring0 */
package m.b.core;

import m.b.core.objs.LandingGround;
import m.gfx.*;
import m.util.*;

/**
 * not obligatory square
 * not obligatory in "right" position
 */
public class Square extends Drawable {
  public Sprite sprite;

  private BufGfx b;

  private static final int halfSize=Config.squareSize/2;

  public Square(Sprite s, int xMap, int yMap, World w, boolean isShape,
      int lvl) {
    this(s, xMap*Config.squareSize+halfSize, yMap*Config.squareSize+halfSize,
        Config.squareSize, Config.squareSize, w, isShape, lvl);
  }

  public Square(Sprite s, int x, int y, int width, int height,
      World w, boolean isShape, int lvl) {
    super(x, y, width, height, isShape, lvl, w);
    sprite=s;
    b=w.g.b;
  }

  public void draw() {
    b.drawRangeCheck(sprite, (int)(x-hw-screen.cameraX()),
        (int)(y-hh-screen.cameraY()));
  }

  public void draw(int xScreen, int yScreen, int xScreenBorder,
      int yScreenBorder) {
    int xxStart=xScreenStart();
    int yyStart=yScreenStart();
    if (xScreen<xxStart) xScreen=xxStart;
    if (yScreen<yyStart) yScreen=yyStart;
    int xxScreenBorder=xScreenBorder();
    int yyScreenBorder=yScreenBorder();
    if (xxScreenBorder<xScreenBorder) xScreenBorder=xxScreenBorder;
    if (yyScreenBorder<yScreenBorder) yScreenBorder=yyScreenBorder;
    int[] b=this.b.b;
    int[] p=sprite.b;
    int yyy=U77.rem(yScreen+screen.camY(), (int)sprite.hh);
    boolean warfloor=sprite.name().startsWith("warfloor");
    int xSpriteStart=U77.rem(xScreen+screen.camX(), (int)sprite.hw);
    for (int yy=yScreen; yy<yScreenBorder; yy++) {
      int offset=yy*screen.w+xScreen;
      int pix=warfloor ? (yyy*sprite.w + xSpriteStart) :
        ((yy-yyStart)*sprite.w + (xScreen-xxStart));
      for (int xx=xScreen; xx<xScreenBorder; xx++) {
        b[offset++]=p[pix++];
      }
      yyy++;
    }
  }

  /**
   * For "right" square
   */
  public final int getMapSquareX() {
    return (int)(x/Config.squareSize);
  }

  /**
   * For "right" square
   */
  public final int getMapSquareY() {
    return (int)(y/Config.squareSize);
  }
}
