package m.b.monsters;

import m.b.core.*;
import m.b.monsters.items.*;
import m.gfx.*;

public class Bullet extends Monster {
  private int dir;

  public Bullet(double speed, double x, double y, int dir, World world,
      Screen screen) {
    super(world, x, y, world.g.getSprite("bullet"+dir), 0.000001);
    this.dir=dir;
    mover=new Mover(this, speed, speed, speed);
    mover.setSpeed(speed, dir);
  }

  public void draw() {
    world.g.b.drawRangeCheck(sprite, xScreenStart(), yScreenStart());
  }

  protected void move() {
    mover.move(dir);
    mover.move();
  }

  protected void justDied() {
    world.removeFromMap(this);
    world.objsToRemove.add(this);
  }

  protected boolean onSquare(Square o) {
    dmg(1);
    return false;
  }

  protected boolean onBullet(Bullet b) {
    dmg(1);
    b.dmg(1);
    return false;
  }

  protected boolean onMonster(Monster m) {
    dmg(1);
    if (!m.afterDmg()) m.dmg(Config.Damages.bullet);
    return false;
  }

  protected boolean onItem(Item i) {
    return false;
  }

  protected boolean checkScreenCollision() {
    if (outOfScreen()) dmg(1);
    return false;
  }
}
