package m.b.monsters;

import m.b.core.*;

public class Gun {
  private Monster mon;
  private World world;
  private double lastShotTime;
  private double shotInterval;
  private double bulletSpeed;

  protected Gun(Monster m, World w, double shotInterval, double bulletSpeed) {
    mon=m;
    world=w;
    lastShotTime=-9999999;
    this.shotInterval=shotInterval;
    this.bulletSpeed=bulletSpeed;
  }

  protected final void shoot(int dir) {
    if (mon.time()-lastShotTime>shotInterval) {
      double x=mon.x;
      double y=mon.y;
      double shift=Config.Monsters.Bullet.startShift+
          world.g.getSprite("bullet0").hh;
      if (dir==0) {
        y=mon.yStart()-shift;
      } else if (dir==1) {
        x=mon.xEnd()+shift;
      } else if (dir==2) {
        y=mon.yEnd()+shift;
      } else {
        x=mon.xStart()-shift;
      }
      Bullet bullet=new Bullet(bulletSpeed, x, y, dir, world, world.g.btr.screen);
      world.objsToAdd.add(bullet);
      lastShotTime=mon.time();
    }
  }
}
