package m.b.monsters;

import m.b.core.*;
import m.gfx.*;
import m.util.*;

public class Heli extends Monster {
  /**
   * Direction: 0-up, 1-right, 2-down, 3-left
   */
  private int dir;
  private Sprite flipped;

  public Heli(double x, double y, World world, int direction) {
    super(world, x, y, world.g.getSprite("heli"),
        Config.Monsters.Heli.life);
    lvl=5;
    dir=direction;
    flipped=world.g.getSprite("heliLeft");
    final double speed=Config.Monsters.Heli.maxSpeed;
    mover=new Mover(this, speed, 0, 0);
    mover.setSpeed(speed, dir);
  }

  protected void move() {
    mover.move(dir);
    mover.move();
  }

  public void draw() {
    super.draw();
    Sprite blades=world.g.getSprite("blades"+
        U77.rem((int)(world.g.btr.time.time*
        Config.Monsters.Heli.bladesK), 7));
    int shift=(int)blades.hh;
    if (dir==3) {
      world.g.b.drawTranspRangeCheck(blades, xScreenStart(), yScreenStart());
    } else {
      world.g.b.drawTranspRangeCheck(blades, xScreenBorder()-blades.w,
         yScreenStart());
    }
  }

  protected boolean onSquare(Square o) {
    removeFrom(o);
    mover.stop();
    if (dir==1) dir=3; else dir=1;
    Sprite s=sprite;
    sprite=flipped;
    flipped=s;
    return true;
  }

  protected boolean checkScreenCollision() {
    if (super.checkScreenCollision()) return true;
    if (xEnd()<screen.camX()) {
      if (dir!=1) {
        world.objsToRemove.add(this);
      }
    } else if (xStart()>screen.xEnd()) {
      if (dir!=3) {
        world.objsToRemove.add(this);
      }
    }
    return false;
  }

  protected boolean onMonster(Monster m) {
    if (m instanceof Tank) return false;
    if (!(m instanceof Heli)) return super.onMonster(m);
    removeFrom(m);
    mover.stop();
    m.mover.stop();
    if (dir==1) dir=3; else dir=1;
    Sprite s=sprite;
    sprite=flipped;
    flipped=s;
    return true;
  }
}
