package m.b.monsters;

import m.b.*;
import m.b.core.*;
import m.util.*;

public class Player extends Monster {
  public double bullets;
  private Keyboard77 kbd;
  private double lastShotTime;

  public Player(Keyboard77 keyboard, World world) {
    super(world, (double)world.width/2*Config.squareSize,
        (world.height-3)*Config.squareSize, world.g.getSprite("plane"),
        Config.Monsters.Player.life);
    screen=world.btr.screen;
    screen.setCameraX(0);
    screen.setCameraY(world.height*Config.squareSize-screen.h, world);
    kbd=keyboard;
    lvl=5;
    lastShotTime=0;
    mover=new Mover(this, Config.Monsters.Player.maxStrafeSpeed,
        Config.Monsters.Player.maxSpeed, Config.Monsters.Player.minSpeed);
    mover.zeroYSpeed=Config.cameraSpeed;
    mover.ySpeed=-Config.cameraSpeed;
    bullets=80;
  }

  protected void move() {
    if (kbd.left()) mover.left();
    if (kbd.right()) mover.right();
    if (kbd.up()) {
      mover.up();
    }
    if (kbd.down()) {
      mover.down();
    }
    mover.move();
    if (kbd.ctrl() || kbd.space()) shoot();
  }

  protected void justDied() {
    super.justDied();
    Battery btr=world.g.btr;
    btr.timeWhenLevelCompleted=time();
    btr.logger.log("gameover "+U77.sprecision(time()));
    btr.logger.log("lastcameray "+
        (world.height*Config.squareSize-screen.camY()));
  }

  public boolean afterDmg() {
    return time()-lastDmgTime<Config.Monsters.Player.afterDmgTime;
  }

  protected boolean checkScreenCollision() {
    boolean moved=false;
    if (xStart()<screen.camX()) {
      x=screen.camX()+hw;
      moved=true;
    } else if (xEnd()>screen.xEnd()) {
      x=screen.xEnd()-hw;
      moved=true;
    }
    if (yStart()<screen.camY()) {
      y=screen.camY()+hh;
      moved=true;
    } else if (yEnd()>screen.yEnd()) {
      y=screen.yEnd()-hh;
      moved=true;
    }
    return moved;
  }

  private void shoot() {
    if ((time()-lastShotTime>Config.Intervals.afterShotTime) &&
        (bullets>0)) {
      bullets--;
      Bullet bullet=new Bullet(Config.Monsters.Bullet.speed, x, yStart()-
          Config.Monsters.Bullet.startShift, 0, world, screen);
      bullet.y -= bullet.hh;
      world.objsToAdd.add(bullet);
      lastShotTime=time();
    }
  }
}
