package m.b.monsters;

import m.b.core.*;
import m.b.gfx.*;
import m.gfx.*;

public class Tank extends Monster {
  protected TankAI ai;
  protected Gun gun;

  private TankGfx tankGfx;
  private Gfx gfx;

  public Tank(double x, double y, World world, int direction) {
    super(world, x, y, world.g.getSprite("tank0"),
        Config.Monsters.Tank.life);
    ai=new TankAI(this, world, direction);
    Sprite caterpillar=world.g.getSprite("caterpillar");
    gun=new Gun(this, world, Config.Monsters.Tank.shotInterval,
        Config.Monsters.Tank.bulletSpeed);
    tankGfx=new TankGfx(this, caterpillar);
    gfx=world.g;
  }

  protected void move() {
    ai.move();
  }

  public void draw() {
    tankGfx.draw(gfx.btr.world);
  }

  protected boolean onSquare(Square o) {
    removeFrom(o);
    ai.dir=TankAI.opposite(ai.dir);
    return true;
  }

  protected boolean onMonster(Monster m) {
    if (m instanceof Heli) return false;
    if (!(m instanceof Tank)) return super.onMonster(m);
    removeFrom(m);
    ai.dir=TankAI.opposite(ai.dir);
    return true;
  }
}
