package m.b.monsters;

import m.b.core.*;
import m.gfx.*;
import m.util.*;

public class TankGfx {
  private Tank t;
  private Sprite caterpillar;

  public TankGfx(Tank tank, Sprite caterpillar) {
    t=tank;
    this.caterpillar=caterpillar;
  }

  protected final void draw(World w) {
    BufGfx b=w.g.b;
    drawCatters(b);
    t.sprite=w.g.getSprite("tank"+t.ai.dir);
    if (t.afterDmg()) {
      b.drawTranspWhiteRangeCheck(t.sprite, t.xScreenStart(), t.yScreenStart());
    } else {
      b.drawTranspRangeCheck(t.sprite, t.xScreenStart(), t.yScreenStart());
    }
  }

  private final void drawCatters(BufGfx b) {
    BufGfx cater=new BufGfx(caterpillar, true);
    int start=3-U77.rem((int)t.dist, 4);
    int width=caterpillar.w-2;
    for (int y=start; y<caterpillar.h; y+=4) {
      cater.hline(1, y, width, 0xff000000);
    }
    int xStart1=t.xScreenStart();
    int yStart1=t.yScreenStart();
    int xStart2=t.xScreenStart()+t.sprite.w-cater.w;
    int yStart2=t.yScreenStart();
    if (t.ai.dir==1) {
      cater.rot90NotSquare();
      xStart2=t.xScreenStart();
      yStart2=t.yScreenStart()+t.sprite.h-cater.h;
    } else if (t.ai.dir==2) {
      cater.flipVertical();
    } else if (t.ai.dir==3) {
      cater.flipVertical();
      cater.rot90NotSquare();
      xStart2=t.xScreenStart();
      yStart2=t.yScreenStart()+t.sprite.h-cater.h;
    }
    if (t.afterDmg()) {
      b.drawTranspWhiteRangeCheck(cater, xStart1, yStart1);
      b.drawTranspWhiteRangeCheck(cater, xStart2, yStart2);
    } else {
      b.drawRangeCheck(cater, xStart1, yStart1);
      b.drawRangeCheck(cater, xStart2, yStart2);
    }
  }
}
