package m.b.monsters.items;

import java.util.*;
import m.b.core.*;
import m.b.monsters.*;
import m.util.Time77;

public class Explosion extends Item {
  private static final double duration=370;
  private static final int count = 30;

  private List<Expl> list;
  private double time;

  public Explosion(double x, double y, World world, Monster m) {
    super(world, x, y, world.g.getSprite("expl"));
    lvl=7;
    list=new ArrayList<Expl>();
    double xSpeed=0;
    double ySpeed=0;
    if (!(m instanceof Tank)) {
      xSpeed=m.mover.xSpeed;
      ySpeed=m.mover.ySpeed;
    }
    for (int i=0; i<count; i++) {
      list.add(new Expl(x, y, world, xSpeed, ySpeed));
    }
    time=time();
    setWH(1, 1);
  }

  public void draw() {
    double perc=1-(duration/(time()-time));
    for (Expl e: list) e.draw(perc);
  }

  protected void move() {
    y=world.btr.screen.camY()+(world.btr.screen.h/2);
    for (Expl e: list) e.move();
    if (time+duration<time()) {
      dmg(1);
    }
  }
}
