package m.b.stats;

import java.util.*;
import m.tools.sitestats77.*;
import m.util.*;

public class Game {
  protected String id;
  protected String ip;
  protected String name;
  protected long hisTime;
  /*connection start: my time*/
  protected long time;
  protected double version;
  protected double speed;
  protected boolean bck0;
  protected boolean grass;
  protected double maxSpeed;
  protected double maxStrafeSpeed;
  protected double minSpeed;
  protected double heliMaxSpeed;
  protected String levels;
  protected double tankTurn;
  protected double tankStays;
  protected List<Pair> lastCameraY;
  protected int truelvl;
  protected double bulletSpeed;
  protected double shotInterval;
  protected double nextLvlDelay;
  protected int length;
  private int maxLvl;
  private int lvl;
  protected double cameraSpeed;
  protected double tankSpeed;
  protected double tankForPlayer;
  protected double bulletGrowth;
  protected double defaultA;
  protected double avgFps;
  protected List<Integer> fps;
  protected List<Integer> lvls;
  protected int hits;
  protected int diamonds;

  protected Game(String id) {
    diamonds=0;
    hits=0;
    this.id=id;
    ip=null;
    hisTime=-1;
    time=-1;
    version=-1;
    speed=-1;
    bck0=false;
    grass=false;
    maxSpeed=-1;
    maxStrafeSpeed=-1;
    minSpeed=-1;
    heliMaxSpeed=-1;
    levels="-";
    tankTurn=-1;
    tankStays=-1;
    bulletSpeed=-1;
    shotInterval=-1;
    nextLvlDelay=-1;
    length=0;
    maxLvl=-1;
    lvl=-1;
    cameraSpeed=-1;
    tankSpeed=-1;
    tankForPlayer=-1;
    name="anonymous";
    bulletGrowth=-1;
    defaultA=-1;
    avgFps=-1;
    truelvl=-1;
    lastCameraY=new ArrayList<Pair>();
    fps=new ArrayList<Integer>();
    lvls=new ArrayList<Integer>();
  }

  protected void lastCameraY(double y) {
    lastCameraY.add(new Pair(new Integer(truelvl), new Double(y)));
  }

  protected void diam(int count) {
    if (count>diamonds) diamonds=count;
  }

  protected void lvl(int lvl) {
    if (maxLvl<lvl) maxLvl=lvl;
    this.lvl=lvl;
  }

  protected void fps(int fps) {
    this.fps.add(fps);
  }

  protected void gameover() {
    lvls.add(lvl);
    if (lvl==maxLvl) {
      lvl=666;
    }
  }

  protected void finish() {
    if (lvl!=0) {
      lvls.add(lvl);
    }
    for (int i: fps) {
      avgFps += i;
    }
    avgFps /= fps.size();
  }

  protected final boolean invalid() {
    return ((version<1.02) || (length<=12000) ||
          (hits<5 && length<15000) ||
          (((double)hits)/length*60000<10 && length>12000) ||
          BannedIPs.get().contains(ip));
  }

  protected final boolean approxEquals(Game g) {
    return ((g.bulletSpeed==bulletSpeed)&&
        (g.version==version)&&
        (g.heliMaxSpeed==heliMaxSpeed)&&
        (Math.abs(g.time-time)<10*60*1000)&&
        (g.ip.equals(ip))&&
        (g.speed==speed)&&
        (g.maxSpeed==maxSpeed)&&
        (g.minSpeed==minSpeed));
  }

  public String toString() {
    String t="</td><td>";
    String lngth=U77.leadZeros(U77.ssprecision((((double)length)/1000/60),2), 5);
    String res="<tr><td>"+Date77.datetime(time)+t+
        ip+t+
        SiteStatsUtil.getFirstReferer(ip)+t+
        U77.ssprecision(version, 2)+t+

        lvls.size()+t+
        bck0+t+
        grass+t+
        (!bck0 && !grass)+t+
        U77.ssprecision(maxSpeed, 4)+t+
        U77.ssprecision(maxStrafeSpeed, 3)+t+
        U77.ssprecision(minSpeed, 3)+t+
        U77.ssprecision(heliMaxSpeed, 3)+t+
        levels+t+

        U77.ssprecision(cameraSpeed, 3)+t+
        U77.leadZeros(""+(int)tankTurn, 4)+t+
        U77.ssprecision(bulletSpeed, 3)+t+
        U77.ssprecision(shotInterval, 0)+t+
        U77.ssprecision(nextLvlDelay, 0)+t+


        U77.ssprecision(speed, 3)+t+
        maxLvl+t+
        U77.ssprecision(tankSpeed, 3)+t+
            
        U77.ssprecision(tankForPlayer, 3)+t+
        name+t+
        U77.ssprecision(defaultA, 3)+t+

        U77.leadZeros(""+diamonds, 3)+t+
        lngth+"</td></tr>\n";
    return res;
  }
}
