package m.b.stats;

import java.util.*;
import m.b.core.*;
import m.util.*;
import m.util.supertable.*;

public class Report {
  public static String logfile=Config.logfile;
  private static final String statsDir="C:/tomcat/webapps/ROOT/stats";

  private static FileReader77 fr;
  private static Map<String, Game> parsed;
  private static String id;
  private static Set<String> bannedIps;  

  public static void main(String[] args) {
    logfile="C:/Documents and Settings/Administrator/Desktop/x/battery.log";
    generate();
  }

  public static synchronized List<Tripple> getTop() {
    return (List<Tripple>)Stats.stats().things.get("ramblers");
  }

  public static synchronized String getTopUpdateTime() {
    return (String)Stats.stats().things.get("topupdate");
  }

  public static synchronized final String generate() {
    try {
      parsed=new HashMap<String, Game>();
      bannedIps=new HashSet<String>();
      bannedIps.addAll(BannedIPs.get());
      fr=new FileReader77(logfile);
      boolean somethingNew=true;
      int debugCounter=0;
      while (somethingNew) {
        debugCounter++;
        if (U77.rem(debugCounter, 10)==0) {
        }
        somethingNew=false;
        fr.drop();
        for (int i=0; i<fr.size(); i++) {
          String s=fr.read();
          if (!parsed.containsKey(id(s))) {
            if (id(s)!=null) {
              id=id(s);
              parse(s, i+1);
              somethingNew=true;
              break;
            }
          }
        }
      }
      removeInvalids();
      setRamblers();
      integrate();
      String t="</td><td>";
      String table=
"<table border=\"1\" width=\"2000\">\n"+
"<tr><td>time"+t+"ip"+t+"referer"+t+"v"+t+
"starts"+t+"bck0"+t+"grass"+t+
"carpet"+t+"maxspeed"+t+"maxstrafe"+t+"minspeed"+t+"helimax"+t+
"levels"+t+"camspeed"+t+"tankturn"+t+"bulspeed"+t+"shotinterval"+t+
"nextlvldelay"+t+"speed"+t+"lvl"+t+
"tankSpeed"+t+"tankForPlayer"+t+"name"+t+"a"+t+
"diams"+t+"length</td></tr>\n";
      for (Game game: parsed.values()) {
        table += game.toString();
      }
table += "</table>\n";
      List<String> fields=new ArrayList<String>();
      fields.add("maxspeed");
      fields.add("maxstrafe");
      fields.add("minspeed");
      fields.add("helimax");
      fields.add("tankturn");
      fields.add("bulspeed");
      fields.add("shotinterval");
      fields.add("nextlvldelay");
      fields.add("speed");
      SuperTable.generate(table, statsDir, "length", fields);
      return "Battery Stats: <a href=\"http:"+P.bs+"btrgame.com/stats/by_time.html\">"+
          "generated</a>";
    } catch(Exception e) {
      P.p("m.b.stats.Report.generate(): error:\n"+U77.toString(e));
      return "Battery Stats: error generating for ["+logfile+
          "]<br>\n"+U77.toString(e);
    }
  }

  private static final void setRamblers() {
    Collection<Game> games=parsed.values();
    List<Tripple> ramblers=new ArrayList<Tripple>();
    for (Game g: games) {
      if (g.diamonds>4) {
        ramblers.add(new Tripple(g.name, g.diamonds, g.time));
      }
    }
    Stats.stats().things.put("ramblers", ramblers);
    Stats.stats().recalcTop10();
  }

  private static final void removeInvalids() {
    boolean removed=true;
    while(removed) {
      removed=false;
      for (Game game: parsed.values()) {
        if (game.invalid()) {
          parsed.remove(game.id);
          removed=true;
          break;
        }
      }
    }
  }

  private static final void integrate() {
    if (parsed.values().size()==0) {
      return;
    }
    String idToRemove="-";
    while(idToRemove!=null) {
      if (idToRemove!=null) {
        parsed.remove(idToRemove);
      }
      idToRemove=null;
      for (Game game: parsed.values()) {
        if (idToRemove!=null) break;
        Collection<Game> games=parsed.values();
        for (Game g: games) {
          if (game!=g && g.approxEquals(game)) {
            idToRemove=g.id;
            break;
          }
        }
      }
    }
  }

  private static final void parse(String s, int start) {
    Game game=new Game(id);
    String ip=get(s, "addr:");
    game.ip=ip;
    game.time=getLong(s, "time:");
    for (int i=start; i<fr.size(); i++) {
      s=fr.read();
      if (s.startsWith(id)) {
        /*-192120942 start clienttime:1210001243675*/
        if (starts(s, "start clienttime:")) {
          game.hisTime=getLong(s, "start clienttime:");
        /*-192120942 name chrh*/
        } else if (starts(s, "name ")) {
          game.name=get(s, "name ");
        /*138497150 version 1.0*/
        } else if (starts(s, "version ")) {
          game.version=getDouble(s, "version ");
        /*138497150 speed 1.0*/
        } else if (starts(s, "speed ")) {
          game.speed=getDouble(s, "speed ");
        /*138497150 maxSpeed 0.1*/
        } else if (starts(s, "maxSpeed ")) {
          game.maxSpeed=getDouble(s, "maxSpeed ");
        /*138497150 maxStrafeSpeed 0.05*/
        } else if (starts(s, "maxStrafeSpeed ")) {
          game.maxStrafeSpeed=getDouble(s, "maxStrafeSpeed ");
        /*138497150 minSpeed 0.025*/
        } else if (starts(s, "minSpeed ")) {
          game.minSpeed=getDouble(s, "minSpeed ");
        /*138497150 heliMaxSpeed 0.07*/
        } else if (starts(s, "heliMaxSpeed ")) {
          game.heliMaxSpeed=getDouble(s, "heliMaxSpeed ");
        /*138497150 leveles 4-2-1-3*/
        } else if (starts(s, "levels ")) {
          game.levels=get(s, "levels ");
        /*138497150 cameraSpeed 0.07*/
        } else if (starts(s, "cameraSpeed ")) {
          game.cameraSpeed=getDouble(s, "cameraSpeed ");
        /*138497150 tankSpeed 0.07*/
        } else if (starts(s, "tankSpeed ")) {
          game.tankSpeed=getDouble(s, "tankSpeed ");
        /*138497150 tankForPlayer 0.07*/
        } else if (starts(s, "tankForPlayer ")) {
          game.tankForPlayer=getDouble(s, "tankForPlayer ");
        /*138497150 name M77*/
        } else if (starts(s, "name ")) {
          game.name=get(s, "name ");
        /*138497150 bulletGrowth 0.07*/
        } else if (starts(s, "bulletGrowth ")) {
          game.bulletGrowth=getDouble(s, "bulletGrowth ");
        /*138497150 defaultA 0.07*/
        } else if (starts(s, "defaultA ")) {
          game.defaultA=getDouble(s, "defaultA ");
        /*138497150 kp 4563 mouse*/
        } else if (starts(s, "kp ")) {
          game.length=getInt(s, "kp ");
          game.hits++;
        /*138497150 kr 11862 down*/
        } else if (starts(s, "kr ")) {
          game.length=getInt(s, "kr ");
          game.hits++;
        /*138497150 lvl 1 7002*/
        } else if (starts(s, "lvl ")) {
          game.lvl(getInt(s, "lvl "));
          game.length=lastInt(s);
        /*138497150 totlvl 1*/
        } else if (starts(s, "totlvl ")) {
          game.lvl(getInt(s, "totlvl "));
        /*138497150 fps 10002 47*/
        } else if (starts(s, "fps ")) {
          game.fps(lastInt(s));
          game.length=getInt(s, "fps ");
        /*138497150 lvlcompl 58701*/
        } else if (starts(s, "lvlcompl ")) {
          game.length=getInt(s, "lvlcompl ");
        /*-192120926 gameover 81345*/
        } else if (starts(s, "gameover ")) {
          game.length=getInt(s, "gameover ");
          game.gameover();
        /*138497113 lastcameray 4337*/
        } else if (starts(s, "lastcameray ")) {
          game.lastCameraY(getDouble(s, "lastcameray "));
        /*138497113 lastycamera 4337*/
        } else if (starts(s, "lastycamera ")) {
          game.lastCameraY(getDouble(s, "lastycamera "));
        /*-2127776210 tankTurn 515.141982613915*/
        } else if (starts(s, "tankTurn")) {
          game.tankTurn=getDouble(s, "tankTurn ");
        /*-2127776210 tankStays 515.141982613915*/
        } else if (starts(s, "tankStays")) {
          game.tankStays=getDouble(s, "tankStays ");
        /*-2127776210 bulletSpeed 0.41032491769717605*/
        } else if (starts(s, "bulletSpeed")) {
          game.bulletSpeed=getDouble(s, "bulletSpeed ");
        /*-2127776210 shotInterval 403.468556330883*/
        } else if (starts(s, "shotInterval")) {
          game.shotInterval=getDouble(s, "shotInterval ");
        /*-2127776210 nextLevelDelay 403.468556330883*/
        } else if (starts(s, "nextLvlDelay ")) {
          game.nextLvlDelay=getDouble(s, "nextLvlDelay ");
        /*-2127776210 bck0 false*/
        } else if (starts(s, "bck0")) {
          game.bck0=get(s, "bck0 ").equals("true");
        /*-2127776210 grass false*/
        } else if (starts(s, "grass")) {
          game.grass=get(s, "grass ").equals("true");
        /*810906999 diam 3*/
        } else if (starts(s, "diam ")) {
          game.diam(getInt(s, "diam "));
        }
      }
    }
    game.finish();
    parsed.put(id, game);
  }

  private static final String get(String s, String after) {
    int from=s.indexOf(after)+after.length();
    int to=s.indexOf(" ", from);
    if (to==-1) to=s.length();
    return s.substring(from, to);
  }

  private static final int getInt(String s, String after) {
    return Integer.parseInt(get(s, after));
  }

  private static final boolean getBool(String s, String after) {
    return get(s, after).equals("true");
  }

  private static final long getLong(String s, String after) {
    return Long.parseLong(get(s, after));
  }

  private static final double getDouble(String s, String after) {
    return Double.parseDouble(get(s, after));
  }

  private static final String last(String s) {
    return s.substring(s.lastIndexOf(" ")+1);
  }

  private static final int lastInt(String s) {
    return Integer.parseInt(last(s));
  }

  private static final boolean starts(String s, String with) {
    try {
      int from=s.indexOf(" ")+1;
      return s.substring(from).startsWith(with);
    } catch(Exception e) {
      return false;
    }
  }

  private static final String id(String s) {
    try {
      return s.substring(0, s.indexOf(" "));
    } catch(Exception e) {
      return null;
    }
  }
}
