package m.b.stats;

import java.io.*;
import java.util.*;
import javax.servlet.http.*;
import m.b.core.*;
import m.util.*;

public class Stats implements Serializable {
  private static final String saveDir =
      "C:/tomcat/webapps/ROOT/stats";
  private static final String fileName="gamestats.serialized";
  private static long hitsTillAutosave;
  private static Stats stats=null;

  private static final Random r=new Random(System.currentTimeMillis());

  /**
   * key - ip, value - list of maps(key-paramname (example: "time"))
   */
  protected Map<String, List<Map<String, String>>> users;

  protected Map<String, Object> things;

  protected Stats() {
    users=new HashMap<String, List<Map<String, String>>>();
    things=new HashMap<String, Object>();
    things.put("ramblers", new ArrayList<Tripple>());
    hitsTillAutosave=50;
  }

  public String recalcTop10() {
    List<Tripple> ramblers=(List<Tripple>)things.get("ramblers");
    Collections.sort(ramblers, new Comparator() {
      public int compare(Object o1, Object o2) {
        Tripple t1=(Tripple)o1;
        Tripple t2=(Tripple)o2;
        int v1=(Integer)t1.o2;
        int v2=(Integer)t2.o2;
        return v2-v1;
      }
      public boolean equals(Object o) {
        return false;
      }
    });
    int border=ramblers.size();
    if (border>10) border=10;
    things.put("topupdate", Date77.datetime());
    String res=
"<center><b>Top "+border+"</b></center>\n"+
"<table border=\"0\" cellspacing=\"1\" cellpadding=\"1\" width=\"140\" bgcolor=\"b9b99a\">\n"+
"  <tr><td bgcolor=\"000000\" align=\"left\"><b>Rank</b></td><td bgcolor=\"000000\" align=\"center\"><b>Name</b></td><td bgcolor=\"000000\" align=\"right\"><img src=\"diam.png\" border=\"0\" alt=\"Diamonds\" title=\"Diamonds\"></td></tr>\n";
    for (int i=0; i<border; i++) {
      res+=
"<tr><td bgcolor=\"000000\" align=\"left\">"+(i+1)+"</td><td bgcolor=\"000000\" align=\"left\">"+ramblers.get(i).o1+"</td><td bgcolor=\"000000\" align=\"right\">"+ramblers.get(i).o2+"</td></tr>\n";
    }
    res+=
"</table>\n"+
"<center>"+things.get("topupdate")+"</center>\n";
    things.put("top10", res);
    return res;
  }

  public String top10() {
    if (things.get("top10")!=null) {
      return (String)things.get("top10");
    }
    return (String)things.get("top10");
  }

  public static Stats stats() {
    if (stats == null) {
      try {
        stats=(Stats)Serialization.deserialize(saveDir+"/"+fileName);
        try {
          ((List<Pair>)(stats.things.get("ramblers"))).get(0);
        } catch(Exception ex) {
          stats.things.put("ramblers", new ArrayList<Tripple>());
        }
      } catch(Exception e) {
        P.p("Error deserializing m.b.Stats.stats:\n  "+U77.toString(e));
        stats=new Stats();
      }
      hitsTillAutosave=50;
    }
    return stats;
  }

  public static synchronized void save() {
    if (stats == null) {
      stats();
    } else {
      Serialization.serialize(stats, saveDir+"/"+fileName);
    }
    P.p("m.b.Stats: saved");
  }

  public synchronized String getParams(HttpServletRequest req) {
    String ip=req.getRemoteAddr();
    List<Map<String, String>> paramList=users.get(ip);
    if (paramList==null) {
      paramList=new ArrayList<Map<String, String>>();
      users.put(ip, paramList);
    }
    Map<String, String> params=new HashMap<String, String>();
    paramList.add(params);
    params.put("time", ""+System.currentTimeMillis());
    params.put("version", U77.ssprecision(Config.version, 2));
    params.put("speed", ""+Config.speed);
    params.put("maxSpeed", ""+Config.Monsters.Player.maxSpeed);
    params.put("maxStrafeSpeed", ""+Config.Monsters.Player.maxStrafeSpeed);
    params.put("minSpeed", ""+Config.Monsters.Player.minSpeed);
    params.put("heliMaxSpeed", ""+Config.Monsters.Heli.maxSpeed);
    params.put("levels", getLevels());
    params.put("cameraSpeed", ""+Config.cameraSpeed);
    params.put("tankSpeed", ""+Config.Monsters.Tank.speed);
    params.put("tankForPlayer", ""+Config.Monsters.Tank.wishForPlayer);
    params.put("bulletGrowth", ""+Config.bulletGrowth);
    params.put("defaultA", ""+Config.Monsters.defaultA);
    params.put("tankTurn", ""+Config.Monsters.Tank.turnDistance);
    params.put("tankStays", ""+Config.Monsters.Tank.stayPeriod);
    params.put("monAfterDmg", ""+Config.Monsters.afterDmgTime);
    params.put("afterDmg", ""+Config.Monsters.Player.afterDmgTime);
    params.put("bulletSpeed", ""+Config.Monsters.Bullet.speed);
    params.put("shotInterval", ""+Config.Intervals.afterShotTime);
    params.put("nextLvlDelay", ""+Config.Intervals.nextLevelDelay);
    params.put("bck0", "false");
    params.put("grass", "true");
    if (--hitsTillAutosave==0) {
      hitsTillAutosave=50;
      save();
    }
    String res="";
    for (Map.Entry param: params.entrySet()) {
      if (!param.getKey().toString().equals("time")) {
        res +=
"<param name=\""+param.getKey()+"\" value=\""+param.getValue()+"\">\n";
      }
    }
    return res;
  }

  private final String getLevels() {
    return Config.getLevelsString();
  }

  private static final double rnd(double d) {
    if (r.nextDouble()>0.1) {
      return rnd(d, 0.2);
    } else return rnd(d, 0.4);
  }

  private static final double rnd2(double d) {
    if (r.nextDouble()>0.1) {
      return rnd(d, 0.3);
    } else return rnd(d, 0.4);
  }

  private static final double rnd(double d, double amp) {
    double ampl=amp*d;
    return r.nextDouble()*ampl*2+d-ampl;
  }
}
