package m.tools.javastats77;

import java.io.*;
import java.util.*;
import m.util.*;

class Node implements Comparable {
  protected long sum;
  protected long childSum;
  protected Node parent;
  protected List<Node> childs;
  protected File f;
  protected String path;
  protected int lvl;

  protected Node(Node parent, File f, int lvl, String path) {
    if (JavaStats77.outputProgress) P.pp(".");
    this.parent=parent;
    this.path=path;
    this.lvl=lvl;
    childSum=0;
    this.f=f;
    if (f.isFile()) {
      sum=f.length();
    } else {
      sum=0;
    }
    childs=new ArrayList<Node>();
  }

  protected void count() {
    File[] files=f.listFiles();
    for (File f: files) {
      if (f.isFile()) {
        sum += f.length();
        childs.add(new Node(this, f, lvl+1, path));
      } else {
        Node n=(new Node(this, f, lvl+1, path+f.getName()+"/"));
        childs.add(n);
        n.count();
        childSum += n.sum + n.childSum;
      }
    }
  }

  protected String getPackageName() {
    return parent==null?f.getName():parent.getPackageName()+"."+f.getName();
  }

  public int compareTo(Object o) {
    Node n=(Node)o;
    if (f.isDirectory()) {
      if (n.f.isDirectory()) {
        return f.getName().compareTo(n.f.getName());
      } else {
        return -1;
      }
    } else {
      if (n.f.isDirectory()) {
        return 1;
      } else {
        return f.getName().compareTo(n.f.getName());
      }
    }
  }
}
