package m.tools.nn77;

import java.util.*;
import m.util.*;

public class Advanced {
  private Net77 net;
  private List<Akson> aksons;

  /**
   * Call it when the net is built.
   */
  public Advanced(Net77 nn) {
    net=nn;
    setAksons();
  }

  public Akson akson(long inp, long out) {
    for (Akson a: aksons) {
      if (a.input.id==inp && a.output.id==out) return a;
    }
    net.printer.print();
    throw new RuntimeException("no akson "+inp+"-"+out);
  }

  private void setAksons() {
    aksons=new ArrayList<Akson>();
    for (Neuron n: net.outputs) {
      setAksons(n);
    }
  }

  private void setAksons(Neuron n) {
    for (Akson a: n.inputs) {
      if (!aksons.contains(a)) {
        aksons.add(a);
        setAksons(a.input);
      }
    }
  }
}
