package m.tools.nn77;

import java.util.*;
import m.util.*;

public class Akson {
  private static long nextId=0;

  protected long id;
  protected double weight;
  protected Neuron input;
  protected Neuron output;

  private Net77 net;
  private boolean changed;

  protected Akson(Neuron inp, Neuron out, Net77 nn) {
    id=nextId++;
    weight=0;
    input=inp;
    output=out;
    net=nn;
    changed=false;
    inp.outputs.add(this);
    out.inputs.add(this);
  }

  protected double weight() {
    if (changed) return weight;
    weight+=net.learningRate*output.error*input.value;
    changed=true;
    return weight;
  }

  /**
   * @param inputs Drop except biases.
   */
  public void dropChangedRec(List<Neuron> netInputs, Set<Akson> dropped) {
    if (dropped.contains(this)) return;
    dropped.add(this);
    changed=false;
    if (!(input.inputs.isEmpty() && !netInputs.contains(input))) {
      for (Akson a: input.inputs) {
        a.dropChangedRec(netInputs, dropped);
      }
    }
  }

  public String toString() {
    return "A["+id+"] "+input.id+"-"+output.id;
  }
}
