package m.tools.sitestats77;

import java.util.*;
import m.util.*;

public class SiteStatsUtil {
  public synchronized static final String getFirstReferer(String ip) {
    try {
      if (SiteStats.stats==null) {
        SiteStats.init();
      }
      String res=SiteStats.stats.users.get(ip).hits.get(0).referer;
      if (res==null) return "";
      if (res.length()>130 && res.indexOf("<a href=")==-1) {
        return "<a href=\""+res+"\">long...</a>";
      } else return res;
    } catch(Exception e) {
      return "";
    }
  }

  public synchronized static final String serveReferers() {
    try {
      List<Hit> hits=SiteStats.stats.allHits();
      for (Hit hit: hits) serveReferer(hit);
      return "SiteStatsUtil.serverReferers(): ok<br>\n";
    } catch(Exception e) {
      P.p("SiteStatsUtil.serveReferers():\n"+U77.toString(e));
      return "SiteStatsUtil.serverReferers(): error<br>\n"+U77.toString(e);
    }
  }

  private static void serveReferer(Hit hit) {
    String referer=hit.referer;
    if (referer==null) referer="";
    if (referer.endsWith("long...</a>")) {
      referer=referer.substring("<a href\"".length(), referer.lastIndexOf("\">long..."));
    }
    if (referer.startsWith("ref=\"")) referer=referer.substring("ref=\"".length());
    if (referer.startsWith("http:"+P.bs+"javastats77.btr")) {
      referer="javastats77 "+referer.substring(("http:"+P.bs+"javastats77.btrgame.com").length());
    } else if (referer.equals("http:"+P.bs+"freshmeat.net/")) {
      referer="<a href=\""+referer+"\">FM</a>";
    } else if (referer.startsWith("http:"+P.bs+"www.javagaming.org/forums/index.php")) {
      referer="<a href=\""+referer+"\">javagaming.org forums</a>";
    } else if (referer.startsWith("http:"+P.bs+"freshmeat.net/projects/javastats77/")) {
      referer="<a href=\""+referer+"\">FM JavaStats77</a>";
    } else if (referer.startsWith("http:"+P.bs+"freshmeat.net/projects/btrgame/")) {
      referer="<a href=\""+referer+"\">FM Battery</a>";
    } else if (referer.equals("http:"+P.bs+"freshmeat.net/lounge/projects/")) {
      referer="<a href=\""+referer+"\">FM lounge</a>";
    } else if (referer.equals("http:"+P.bs+"freshmeat.net/~M77/")) {
      referer="<a href=\""+referer+"\">FM M77</a>";
    } else if (referer.startsWith("http:"+P.bs+"freshmeat.net/")) {
      referer="<a href=\""+referer+"\">FM page</a>";
    } else if (referer.startsWith("http:"+P.bs+"sourceforge.net/projects/javastats77")) {
      referer="<a href=\""+referer+"\">SF JavaStats77</a>";
    } else if (referer.startsWith("http:"+P.bs+"sourceforge.net/projects/battery")) {
      referer="<a href=\""+referer+"\">SF Battery</a>";
    } else if (referer.startsWith("http:"+P.bs+"www.google.") ||
        referer.startsWith("http:"+P.bs+"google.")) {
      referer="<a href=\""+referer+"\">Google page</a>";
    } else if (referer.startsWith("http:"+P.bs+"pagead2.googlesyndication.com")) {
      referer="<a href=\""+referer+"\">Google add</a>";
    } else if (referer.startsWith("http:"+P.bs+"www.java-forums.org")) {
      referer="<a href=\""+referer+"\">java-forums page</a>";
    } else if (referer.startsWith("<a href \"")) {
      referer="<a href="+referer.substring("<a href= ".length());
    } else if (referer.startsWith("<a href=http")) {
      referer="<a href=\""+referer.substring(referer.indexOf("http:"+P.bs+""));
    } else if (referer.startsWith("< href")) {
      referer="<a "+referer.substring(referer.indexOf("href=\""));
    } else if (referer.length()>130 && referer.indexOf("<a href=")==-1) {
      referer="<a href=\""+referer+"\">long...</a>";
    } else if (referer.indexOf("http%3A%2F%2Fwww.bubblebox.com%2Fgame%2FAction%2F954.htm&frm=0&cc=100&ga_vid=945723757.1211038971&ga_sid=1211038971&ga_hid=1502287258&ga_fc=true&flash=9.0.124&u_h=600&u_w=800&u_ah=570&u_aw=800&u_cd=16&u_tz=180&u_his=3&u_java=true&u_nplug=20&u_nmime=77")!=-1) {
      referer="<a href=\"http%3A%2F%2Fwww.bubblebox.com%2Fgame%2FAction%2F954.htm&frm=0&cc=100&ga_vid=945723757.1211038971&ga_sid=1211038971&ga_hid=1502287258&ga_fc=true&flash=9.0.124&u_h=600&u_w=800&u_ah=570&u_aw=800&u_cd=16&u_tz=180&u_his=3&u_java=true&u_nplug=20&u_nmime=77\">long...</a>";
    }
    
    hit.referer=referer;
  }
}
